function classEstimate = multiCentroid_classifyLocalNearestCentroid( ...
  neighborhoodSizeVec, neighborIdx, trainMatSim, testMatSim, trainClass)
%multiCentroid_classifyLocalNearestCentroid - multi-centroid helper function.
%
% USAGE
% classEstimate = multiCentroid_classifyLocalNearestCentroid( ...
%   neighborhoodSizeVec, neighborIdx, trainMatSim, testMatSim, trainClass)

% Written by Luca Cazzanti, engineer
% Applied Physics Laboratory, University of Washington, Dec 2006.
%$Id:$
%$DateTime:$
%$Author:$

[nData, notUsed] = size(testMatSim); %#ok
classEstimate = [];
for iNeighbor = neighborhoodSizeVec(:).'
  classEst = zeros(nData,1);
  
  for iData = 1:nData
    neighborsToPick = neighborIdx(iData,1:iNeighbor);
    neighborClassLabels = trainClass(neighborsToPick);
    testPointSim = testMatSim( iData, neighborsToPick );
    neighborSimMat = trainMatSim( :, neighborsToPick );
    neighborSimMat = neighborSimMat( neighborsToPick, : );
    
    classEst(iData) = classifyLocalNearestCentroid(testPointSim, neighborSimMat, ...
      neighborClassLabels, 'maxSumSim');
  end % for iData
  
  % This matrix will be nTrain-by-(maxNeighbors-1) when loop is done
  classEstimate = [classEstimate classEst(:)];
end %for iNeighbor

return