function maxSize = determineMaxNeighborhoodSizeByClass(classLabels, ...
  crossValIdxCell, testIdxMat)
%determineMaxNeighborhoodSizeByClass - 

% Written by Luca Cazzanti, engineer.
% Applied Physics Laboratory, University of Washington, Jan 2009.
%$Id:$
%$DateTime:$
%$Author:$



maxSize = length(classLabels);

nTests = size(testIdxMat,1);
for iTest = 1:nTests
  testIdx = testIdxMat(iTest, :);
  crossValIdxMat = crossValIdxCell{iTest};
 
  nFolds = size(crossValIdxMat, 1);
  for iFold = 1:nFolds
    crossValIdx = crossValIdxMat(iFold,:);
    crossValIdx(crossValIdx == 0) = []; % take out any remaining filler values
    
    thisFoldTrainIdx = 1:length(classLabels);
    thisFoldTrainIdx = setdiff(thisFoldTrainIdx, testIdx);
    thisFoldTrainIdx = setdiff(thisFoldTrainIdx, crossValIdx);
    
    thisFoldClassLabels = classLabels(thisFoldTrainIdx);
    classSize = hist(thisFoldClassLabels, unique(thisFoldClassLabels));
    
    maxSize = min( [maxSize min(classSize)]);
    
  end % for iFold
end % for iTest

return