function classEst = classifyMaximumMeanSimilarity(testPointSim, classLabels)
%classifyMaximumMeanSimilarity
%
% USAGE classEst = classifyMaximumMeanSimilarity(simVec, classLabels);
% TO DO

% Written by Luca Cazzanti, Sept. 2010.

uniqueClassLabels = unique(classLabels);
nClasses = length(uniqueClassLabels);
meanSimVec = -1e6 * ones(nClasses,1);
classPriors = 1e-6 * ones(nClasses, 1);
for iClass = 1:nClasses
  idx = classLabels == uniqueClassLabels(iClass);
  meanSimVec(iClass) = mean(testPointSim(idx));
  classPriors(iClass) = sum(idx);
end

% Laplace correction to priors - not sure we need it but it's consistent
classPriors = (classPriors + 1)/ (sum(classPriors) + nClasses);

[sortedSimVec, sortIdx] = sort(meanSimVec);
sortedClassLabels = uniqueClassLabels(sortIdx);
sortedClassPriors = classPriors(sortIdx);

% Are there any ties for maximum sim? Break them according to class prior
tieIdx = sortedSimVec == sortedSimVec(end); % assumes similarity so max is last element
%tieSims  = sortedSimVec(tieIdx);
tiePriors = sortedClassPriors(tieIdx);
tieLabels = sortedClassLabels(tieIdx);

[notUsed, maxIdx] = max(tiePriors); %#ok
 classEst = tieLabels(maxIdx);
 